--[[
// 0 = None
// 1 = Warrior          PLATE
// 2 = Paladin          PLATE
// 3 = Hunter           CHAIN
// 4 = Rouge            LEATHER
// 5 = Priest           CLOTH
// 6 = DeathKinght      PLATE
// 7 = Shaman           CHAIN
// 8 = Mage             CLOTH
// 9 = Warlock          CLOTH
// 10 = Monk            LEATHER
// 11 = Druid           LEATHER
// 12 = Demon Hunter    LEATHER
--]]

Rolling = {}
ClassSpecify = {}
ClassSpecify[0] = "none"
ClassSpecify[1] = "Plate"
ClassSpecify[2] = "Plate"
ClassSpecify[3] = "Chain"
ClassSpecify[4] = "Leather"
ClassSpecify[5] = "Cloth"
ClassSpecify[6] = "Plate"
ClassSpecify[7] = "Chain"
ClassSpecify[8] = "Cloth"
ClassSpecify[9] = "Cloth"
ClassSpecify[10] = "Leather"
ClassSpecify[11] = "Leather"
ClassSpecify[12] = "Leather"

local _, _, pc = UnitClass("player")
PlayerClass = ClassSpecify[pc]
local f = CreateFrame("Frame")
local name, addon = ...
local login = true
version = GetAddOnMetadata(name, "Version")
local _rollMessageTailRegex = RANDOM_ROLL_RESULT:gsub("%(", "%%("):gsub("%)", "%%)"):gsub("%%d", "(%%d+)"):gsub("%%%d+%$d", "(%%d+)"):gsub("%%s", ""):gsub("%%%d+%$s", "").. "$"

local function onevent(self, event, arg1, ...)
    if(login == true and ((event == "ADDON_LOADED" and name == arg1) or (event == "PLAYER_LOGIN"))) then
        login = nil
        if not RollingI then RollingI = { } end
        if not RollingI.XPos then
            RollingI.XPos = 0
            RollingI.YPos = 0
            RollingI.Default = {}
            RollingI.Default.WinChat = "%p won %i by Rolling with number %n."
            RollingI.Default.Start = "Roll %i."
            RollingI.Default.Cancel = "Sorry. it was a mistake. I cancel the roll!"
            RollingI.WinChat = "%p won %i by Rolling with number %n."
            RollingI.Start = "Roll %i."
            RollingI.CancelMessage = false
            RollingI.Cancel = "Sorry. it was a mistake. I cancel the roll!"
        end
    end
end

f:RegisterEvent("ADDON_LOADED")
f:RegisterEvent("PLAYER_LOGIN")
f:SetScript("OnEvent", onevent)

local function finish()
    if rolling == true then
        if playerroll[1] then
            table.sort(playerroll, function(a,b) return a>b end)
            local text = RollingI.WinChat:gsub("%%i", item)
            local text = text:gsub("%%p", playerdata[playerroll[1]])
            local text = text:gsub("%%n", playerroll[1])
            SendChatMessage(text.." Addons by 'Rolling Manager'", group)
            --SendChatMessage(playerdata[playerroll[1]].." won "..item.."  by Rolling with number "..playerroll[1]..". Addons by 'Rolling Manager'", "RAID")
            clear()
            fr:Hide()
        else
            clear()
            fr:Hide()
            print("|cff00ccff[Rolling] |cFFFF0000No one wanted it.")
        end
    else
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    end
end

local function cancel()
    if rolling == true then
        SendChatMessage(RollingI.Cancel .." Addons by 'Rolling Manager'", group)
        clear()
        fr:Hide()
    else
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    end
end

local function recommend()
    if rolling == true then
        print("Coming soon")
        fr:Hide()
    else
        print("|cff00ccff[Rolling] |cFFFF0000You didn't started a roll.")
    end
end

function clear()
    fr.txt1:SetText("")
    fr.txt2:SetText("")
    fr.txt3:SetText("")
    fr.recommend:SetText("")
    fr.recommended:SetText("")
    loop = nil
    rolling = false
    playerdatac = {}
    playerdata = {}
    playerdatan = {}
    playerdatai = {}
    playerdatain = {}
    playerroll = {}
    classcheck = nil
    item = nil
end

fr.ennd:SetScript("OnClick", function()
    finish()
end)

fr.cancel:SetScript("OnClick", function()
    cancel()
end)

fr.recommendb:SetScript("OnClick", function()
    recommend()
end)

clear()

f:RegisterEvent("CHAT_MSG_SYSTEM")
f:SetScript("OnEvent",function(_,_,...)
    if rolling == true then
        local msg, arg2 = ...
        if msg then
            local roll, min, max = msg:match(_rollMessageTailRegex)
            roll = tonumber(roll)
            min = tonumber(min)
            max = tonumber(max)
            if roll then
                local name = msg:gsub("%s*" .. _rollMessageTailRegex, "")
                if playerdatan[name] then
                    print("|cFFFF0000"..name.. " tried to rolling again. (But it doesn'T count, it count his first one)")
                elseif min == 1 or min == 0 and max == 100 then
                    local _, _, pc = UnitClass(name)
                    playerdatac[name] = ClassSpecify[pc]
                    local ilvl = GetAverageItemLevel(name)
                    local ilvln = floor(ilvl + 0.5)
                    playerdata[roll] = name
                    playerdatan[name] = roll
                    playerdatain[ilvln] = name
                    table.insert(playerdatai, ilvln)
                    table.sort(playerdatai, function(a,b) return a>b end)
                    table.insert(playerroll, roll)
                    table.sort(playerroll, function(a,b) return a>b end)
                    message = nil
                    if playerroll[3] then
                        fr.recommend:SetText("Recommend Player:")
                        fr.recommendb:SetEnabled(true)
                        if classcheck ~= true then
                            loop = #playerdatai
                            while loop > 0 do
                                if PlayerClass == playerdatac[playerdatain[playerdatai[loop]]] then
                                    fr.recommended:SetText(playerdatain[playerdatai[loop]])
                                    loop = 0
                                else
                                    loop = loop - 1
                                end
                            end
                        else
                            --print(playerdatain[playerdatai[#playerdatai]])
                            fr.recommended:SetText(playerdatain[playerdatai[#playerdatai]])
                        end
                    end
                    if classcheck ~= true then
                        if playerroll[1] ~= nil and playerdatac[playerdata[playerroll[1]]] ~= PlayerClass then
                            fr.txt1:SetText("|cFFFF0000Not specify Class item.|r")
                        elseif playerroll[1] ~= nil then
                            fr.txt1:SetText("")
                        end
                        if playerroll[2] ~= nil and playerdatac[playerdata[playerroll[2]]] ~= PlayerClass then
                            fr.txt2:SetText("|cFFFF0000Not specify Class item.|r")
                        elseif playerroll[2] ~= nil then
                            fr.txt2:SetText("")
                        end
                        if playerroll[3] ~= nil and playerdatac[playerdata[playerroll[3]]] ~= PlayerClass then
                            fr.txt3:SetText("|cFFFF0000Not specify Class item.|r")
                        elseif playerroll[3] ~= nil then
                            fr.txt3:SetText("")
                        end
                    end
                    if playerroll[3] then
                        message = "|cffffff00[1] |cff0099ff"..playerdata[playerroll[1]].."|cffffff00 Rolled a |cff0099ff"..playerroll[1].."\n\n|cff669999[2] |cff0099ff"..playerdata[playerroll[2]].." |cff669999 Rolled a |cff0099ff"..playerroll[2].."\n\n|cff663300[3] |cff0099ff"..playerdata[playerroll[3]].."|cff663300 Rolled a |cff0099ff"..playerroll[3]
                    elseif playerroll[2] then
                        message = "|cffffff00[1] |cff0099ff"..playerdata[playerroll[1]].."|cffffff00 Rolled a |cff0099ff"..playerroll[1].."\n\n|cff669999[2] |cff0099ff"..playerdata[playerroll[2]].." |cff669999 Rolled a |cff0099ff"..playerroll[2].."\n\n|cff663300[3] -"
                    elseif playerroll[1] then

                        message = "|cffffff00[1] |cff0099ff"..playerdata[playerroll[1]].."|cffffff00 Rolled a |cff0099ff"..playerroll[1].."\n\n|cff669999[2] -\n\n|cff663300[3] -"
                    end
                    if message then
                        fr.text:SetText(message)
                        fr:Show()
                    end
                elseif min ~= 1 and max ~= 100 then
                    print("|cFFFF0000"..name.. " tried to cheat. Min: ("..min..") Max: ("..max..")")
                elseif min ~= 1 then
                    print("|cFFFF0000"..name.. " tried to cheat. Min: ("..min..")")
                elseif max ~= 100 then
                    print("|cFFFF0000"..name.. " tried to cheat. Max: ("..max..")")
                end
            end
        end
    end
end)

SLASH_ROLLED1 = "/rr"
SlashCmdList["ROLLED"] = function(msg)
    local arg, arg1 = strsplit(" ", msg, 2)
    if arg ~= nil then
        if arg == "roll" then
            if arg1 ~= nil then
                if rolling == true then
                    print("|cff00ccff[Rolling] |cFFF4F442Restart session.")
                end
                local itemm, _, _, _, _, _, _, _, ItemLoc = GetItemInfo(arg1)
                if itemm then
                    if IsInRaid(0) then
                        group = "RAID"
                    elseif IsInGroup(0) then
                        group = "PARTY"

                    end
                    if group then
                        clear()
                        if ItemLoc == "INVTYPE_FINGER" or ItemLoc == "INVTYPE_TRINKET" or ItemLoc == "INVTYPE_CLOAK" then
                            classcheck = true
                        end
                        rolling = true
                        item = arg1
                        print("|cff00ccff[Rolling] |cFF00FF00Rolling started!")
                        local text1 = RollingI.Start:gsub("%%i", arg1)
                        SendChatMessage(text1, group)
                    else
                        print("|cFFFF0000You can't start a roll without a Party or Raid.")
                    end
                else
                    print("|cff00ccff[Rolling] |cFFFF0000Invaild argument, Item not linked. '/rr roll [Link]'")
                end
            else
                print("|cff00ccff[Rolling] |cFFFF0000Invaild argument, Item not linked. '/rr roll [Link]'")
            end
        elseif arg == "finish" or arg == "end" then
            finish()
        elseif arg == "cancel" then
            cancel()
        elseif arg == "show" then
            fr:Show()
        end
    end
end